<script lang="ts">
  import {
    Dropdown,
    DropdownItem,
    DropdownMenu,
    DropdownToggle,
    Button,
    Alert,
    TabContent,
    TabPane
  } from '@sveltestrap/sveltestrap';
  import { type FeedbackProvider, suggestedPrompts } from '@components/TeamFeedback/suggestedPrompts';
  import type { Team } from '@models/Team';
  import type { FeedbackPrompt } from '@components/TeamFeedback/suggestedPrompts';
  import BlueteamSelect from '@components/Utils/BlueteamSelect.svelte';
  import { Gql } from '@db';
  import TeamFeedback from '@components/TeamFeedback/TeamFeedback.svelte';
  import Env from '@env';
  import { keycloak } from '@stores';
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();

  export let feedback: FeedbackPrompt[] = [];
  let selectedTeam: Team | null = null;
  $: {
    // Runs if selectedTeam changes
    setFeedback(selectedTeam, selectedGroup);
  }

  let selectedGroup: FeedbackProvider | null = null;

  // Performs the mutation to add new entries and update old ones
  async function updateFeedback(input_objects: FeedbackPrompt[]) {
    const mutation = `
        mutation SubmitEventFeedback($inputObjects: [wrapup_feedback_insert_input!]!) {
          insert_wrapup_feedback(
            objects: $inputObjects, 
            on_conflict: {
              constraint: feedback_event_id_team_id_author_id_prompt_key, 
              update_columns: [answer]
            }
          ) {
            affected_rows
          }
        }
      `;

    // Calling the mutation
    await Gql.query<{ wrapup_feedback: FeedbackPrompt[] }>(mutation, {
      variables: {
        inputObjects: input_objects,
      },
    });
  }

  // Updates the feedback list which should update the page
  async function setFeedback(team: Team | null, group: FeedbackProvider | null) {
    if (!group) {
      // reset feedback if no group is selected
      feedback = [];
      return;
    }

    if (team) {
      // check if this team already has feedback
      const query = `
          query TeamFeedback(
            $teamId: uuid!,
            $eventId: uuid!
            $feedbackGroup: String!
          ) {
          wrapup_feedback(
            where: {
              team_id: {_eq: $teamId},
              event_id: {_eq: $eventId},
              source: {_eq: "staff"},
              group: {_eq: $feedbackGroup}
            }
          ) {
            prompt
            answer
          }
        }
        `;
      const result = await Gql.query<{ wrapup_feedback: FeedbackPrompt[] }>(query, {
        variables: {
          teamId: team.id,
          eventId: Env.EventID,
          feedbackGroup: group,
        },
      });

      if (result.wrapup_feedback.length === 0) {
        // No data found, just put the suggestedPrompts
        feedback = structuredClone(suggestedPrompts[group]);
      }

      console.debug('found existing data', result);
      // recovers the saved data
      feedback = [
        // adds data from the database
        ...result.wrapup_feedback,
        // adds any default prompts that have yet to be saved in the db
        ...structuredClone(
          suggestedPrompts[group].filter(
            (suggested) => !result.wrapup_feedback.map((r) => r.prompt).includes(suggested.prompt),
          ),
        ),
      ];
    }
  }

  // Goes through feedback to build 'entries' then writes them with updateFeedback()
  async function saveAllFeedback() {
    console.log('saving feedback');
    let entries = [];
    // Goes through each FeedbackPrompt in feedback
    entries = feedback
      .filter((f) => f.answer?.trim())
      .map((f) => {
        return {
          author_id: $keycloak.userId,
          team_id: selectedTeam?.id,
          event_id: Env.EventID,
          group: selectedGroup,
          source: 'staff',
          prompt: f.prompt,
          answer: f.answer,
        };
      });

    // Do we have feedback to insert into the database?
    if (entries.length === 0) {
      addNotification({
        position: 'bottom-right',
        text: 'No feedback to save!',
        type: 'error',
        removeAfter: 3000,
      });
      return;
    }

    // Bulk add/insert the data
    await updateFeedback(entries);
    addNotification({
      position: 'bottom-right',
      text: 'Feedback saved!',
      type: 'success',
      removeAfter: 3000,
    });
  }

  function createNewPrompt() {
    // re-assign feedback so svelte knows to update the page, adding an empty object at the end
    feedback = [
      ...feedback,
      {
        prompt: '',
        answer: '',
      },
    ];
  }
</script>

<div class="p-4 mx-auto sticky-top d-flex flex-column flex-lg-row bg-black">
  <div class="flex-grow-1" />
  <div class="flex-grow-1">
    <span>Select a blue team to provide feedback:</span>
    <BlueteamSelect bind:selectedTeam />
  </div>

  <div class="flex-grow-1">
    <span>Select your team with NCAE:</span>
    <Dropdown class="d-inline-block" bind:value={selectedGroup}>
      <DropdownToggle caret>
        {selectedGroup || 'Select group...'}
      </DropdownToggle>
      <DropdownMenu>
        {#each Object.keys(suggestedPrompts) as group}
          <DropdownItem on:click={() => (selectedGroup = group)}>
            {group}
          </DropdownItem>
        {/each}
      </DropdownMenu>
    </Dropdown>
  </div>
  <div class="flex-grow-1" />
  <div>
    <Button color="primary" disabled={!(selectedGroup && selectedTeam)} on:click={createNewPrompt}>
      Create new prompt
    </Button>
    <Button color="success" disabled={!(selectedGroup && selectedTeam)} on:click={saveAllFeedback}>Save</Button>
  </div>
</div>

<Alert class="mx-auto mt-3 text-center" style="width: fit-content" color="primary">
  Each Feedback Prompt should be limited to about one sentence.
</Alert>

{#if selectedGroup && selectedTeam}
  <div class="container-fluid">
    <div class="row row-cols-1 row-cols-lg-2">
      {#each feedback as f}
        <div class="col">
          <TeamFeedback bind:feedback={f} />
        </div>
      {/each}
    </div>
  </div>
{/if}

<div class="container pb-5">
  <h2>Tips to leaving good feedback</h2>
  <ul>
    <li>Check spelling, capitalization, grammar, etc (Use an external editor if you need to)</li>
    <li>Leave feedback that will help them graduate from this competition</li>
    <li>Leave feedback that helps them remember our event: jokes or fun references can be great</li>
    <li>Speak like you are leaving a note to the team</li>
    <li>Don't be mean</li>
    <li>Try to be constructive if negative</li>
    <li>Avoid talking about the team as if it is an internal note to staff</li>
    <li>Avoid comments about not being in discord, comments about lack of communication are fine if constructive</li>
    <li>Avoid congratulations on a win or any comments about the invitational</li>
  </ul>
  <h2>Looking for some inspiration?</h2>
  <h3>This is how your feedback will look on their scorecard.</h3>
  <TabContent>
    {#each [1,2,3,4] as num}
      <TabPane tabId="example{num}" tab="Example {num}" active={1 == num ? true : false}>
        <img
          alt="feedback example {num}"
          src="/assets/img/feedback-examples/feedback{num}.png"
        />
      </TabPane>
    {/each}
  </TabContent>
</div>
